
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   17:35:27 07/30/2007
-- Design Name:   sram_access
-- Module Name:   C:/Dokumente und Einstellungen/A/Eigene Dateien/FPGA/t51/tb_sram_access.vhdl
-- Project Name:  t51
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sram_access
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY tb_sram_access_vhdl IS
END tb_sram_access_vhdl;

ARCHITECTURE behavior OF tb_sram_access_vhdl IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT sram_access
	PORT(
		clk : IN std_logic;
		res : IN std_logic;
		sri_wait : IN std_logic;
		WE_I : IN std_logic;
		STB_I : IN std_logic;
		CYC_I : IN std_logic;
		DAT_I : IN std_logic_vector(15 downto 0);
		ADR_I : IN std_logic_vector(22 downto 0);    
		sri_data : INOUT std_logic_vector(15 downto 0);      
		sri_adr : OUT std_logic_vector(22 downto 0);
		sri_cs : OUT std_logic;
		sri_adv : OUT std_logic;
		sri_oe : OUT std_logic;
		sri_ub : OUT std_logic;
		sri_lb : OUT std_logic;
		sri_we : OUT std_logic;
		sri_clk : OUT std_logic;
		ACK_O : OUT std_logic;
		DAT_O : OUT std_logic_vector(15 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL res :  std_logic := '0';
	SIGNAL sri_wait :  std_logic := '0';
	SIGNAL WE_O :  std_logic := '0';
	SIGNAL STB_O :  std_logic := '0';
	SIGNAL CYC_O :  std_logic := '0';
	SIGNAL DAT_O :  std_logic_vector(15 downto 0) := (others=>'0');
	SIGNAL ADR_O :  std_logic_vector(22 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL sri_data :  std_logic_vector(15 downto 0);

	--Outputs
	SIGNAL sri_adr :  std_logic_vector(22 downto 0);
	SIGNAL sri_cs :  std_logic;
	SIGNAL sri_adv :  std_logic;
	SIGNAL sri_oe :  std_logic;
	SIGNAL sri_ub :  std_logic;
	SIGNAL sri_lb :  std_logic;
	SIGNAL sri_we :  std_logic;
	SIGNAL sri_clk :  std_logic;
	SIGNAL ACK_I :  std_logic;
	SIGNAL DAT_I :  std_logic_vector(15 downto 0);

	CONSTANT PERIOD: time := 20 ns;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: sram_access PORT MAP(
		clk => clk,
		res => res,
		sri_adr => sri_adr,
		sri_data => sri_data,
		sri_cs => sri_cs,
		sri_adv => sri_adv,
		sri_oe => sri_oe,
		sri_ub => sri_ub,
		sri_lb => sri_lb,
		sri_we => sri_we,
		sri_clk => sri_clk,
		sri_wait => sri_wait,
		WE_I => WE_O,
		STB_I => STB_O,
		CYC_I => CYC_O,
		ACK_O => ACK_I,
		DAT_I => DAT_O,
		ADR_I => ADR_O,
		DAT_O => DAT_I
	);

	clk <= not clk after PERIOD/2;
	res <= '1', '0' after 100 ns;

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- read cycle
		ADR_O <= (others => '1');
		CYC_O <= '1';
		STB_O <= '1';
		wait for 10 * PERIOD;
		assert ACK_I = '1';
		CYC_O <= '0';
		STB_O <= '0';
		ADR_O <= (others => '0');
		wait for 2 * PERIOD;
		assert ACK_I = '0';

		-- write cycle
		ADR_O <= (others => '1');
		CYC_O <= '1';
		STB_O <= '1';
		WE_O <= '1';
		DAT_O <= (others => '1');
		wait for 10 * PERIOD;
		assert ACK_I = '1';
		CYC_O <= '0';
		STB_O <= '0';
		ADR_O <= (others => '0');
		DAT_O <= (others => '0');
		wait for 2 * PERIOD;
		assert ACK_I = '0';

		report "finished" severity failure;
		--wait; -- will wait forever
	END PROCESS;

END;
